#ifndef _ArichGeo_hh_
#define _ArichGeo_hh_
#include <iostream>
#include <CLHEP/config/CLHEP.h>
#include <CLHEP/Vector/ThreeVector.h>
#include "CLHEP/Random/Randomize.h"

using namespace std;


#define max(x,y) (x>y) ? x : y
#define min(x,y) (x<y) ? x : y

#define sqr(x)   ((x)*(x))

class ArichGeo{

public:
  
  ArichGeo(){};
  ~ArichGeo(){};
  Hep3Vector Perpendicular(Hep3Vector x,Hep3Vector n);
  HepDouble  RayPlaneDistance(Hep3Vector r, Hep3Vector dir, Hep3Vector norm,HepDouble d);
  Hep3Vector RayToPlane(Hep3Vector r, Hep3Vector dir, Hep3Vector norm,HepDouble d);
  HepDouble  RayTubeDistance(Hep3Vector r, Hep3Vector dir, Hep3Vector p,Hep3Vector norm,HepDouble d);
  Hep3Vector RayToTube(Hep3Vector r, Hep3Vector dir, Hep3Vector p,Hep3Vector norm,HepDouble d);
  Hep3Vector Direction(HepDouble theta, HepDouble fi);
  Hep3Vector Rotation(Hep3Vector z, Hep3Vector vin);
  Hep3Vector RayTrace(Hep3Vector r, Hep3Vector dir);
  Hep3Vector Refraction(Hep3Vector dir, Hep3Vector norm, HepDouble refind);
  HepInt ReflectionRefraction(Hep3Vector &dir, Hep3Vector &pol, Hep3Vector &norm, HepDouble refind);
  HepInt     RotatePhoton(HepDouble the, HepDouble fi, Hep3Vector &dir, Hep3Vector &pol);
  HepInt     RayleighScattering(Hep3Vector &dir, Hep3Vector &pol);
 
};


extern  RanluxEngine *gRanluxEngine;
#include "ArichGeo.icc"
#endif







