#ifndef _ArichHitTab_hh_
#define _ArichHitTab_hh_
#include <CLHEP/config/CLHEP.h>

#include "ArichParticle.hh"
#include "ArichHit.hh"



#define SQPI 2.50662827463
class ArichHitTab{

public:
  
  ArichHitTab( HepInt tr,HepInt ph, HepDouble sig,HepInt ir,HepDouble th_cer,HepDouble fi_cer,HepDouble wt);
  ~ArichHitTab();
  ArichHitTab();
  void GetEntries( HepDouble &sig,HepDouble &th_cer,HepDouble &fi_cer,HepDouble &wt);
  void SetEntries( HepInt tr,HepInt ph, HepDouble sig,HepInt ir,HepDouble th_cer,HepDouble fi_cer,HepDouble wt);
  HepInt fTrack;
  HepInt fHit;
  inline HepDouble theta();
  inline HepDouble phi();
  friend std::ostream& operator<< (std::ostream& o, ArichHitTab& d);

  HepDouble ir;
  HepDouble fSigma;
  HepDouble fThetaCerenkov;
  HepDouble fPhiCerenkov;
  HepDouble fWeight;
  HepDouble utez;
private:
};


inline  ArichHitTab::ArichHitTab(){};
inline  ArichHitTab::~ArichHitTab(){};

inline ArichHitTab::ArichHitTab( HepInt  tr,HepInt ph,HepDouble sig,HepInt ich,HepDouble th_cer,HepDouble fi_cer,HepDouble wt){

  fTrack = tr;
  fHit   = ph;
  fSigma = sig;
  fThetaCerenkov = th_cer;
  fPhiCerenkov   = fi_cer;
  fWeight          = wt;
  ir    = ich;
};

inline void ArichHitTab::SetEntries( HepInt tr,HepInt ph,HepDouble sig,HepInt ich,HepDouble th_cer,HepDouble fi_cer,HepDouble wt){

  fTrack = tr;
  fHit   = ph;
  fSigma = sig;
  fThetaCerenkov = th_cer;
  fPhiCerenkov    = fi_cer;
  fWeight          = wt;
  ir    = ich;
  return;
};

inline void ArichHitTab::GetEntries(HepDouble &sig,HepDouble &th_cer,HepDouble &fi_cer,HepDouble &wt){

  sig    = fSigma;
  th_cer = fThetaCerenkov;
  fi_cer = fPhiCerenkov ;
  wt     = fWeight;
  return;
};



inline HepDouble ArichHitTab::theta(){return fThetaCerenkov;}

inline HepDouble ArichHitTab::phi(){return fPhiCerenkov;}

inline ostream&operator<<(ostream& o, ArichHitTab& d){
  return o << "HitTab " << d.fTrack << endl
	   << "HitTab "  << d.fHit   << endl
	   << "HitTab  theta=" << d.theta()
	   << " phi="   << d.phi()
	   << " wt="    << d.fWeight
	   << " sigma=" << d.fSigma;

}


#endif




